Index: ta/trunk/materials/Muunilinst.material
===================================================================
--- /data/trunk/materials/Muunilinst.material	(revision 8424)
+++ 	(revision )
@@ -1,25 +1,0 @@
-material MuunilinstTex/TEXFACE/planet_Muunilinst.png
-{
-	receive_shadows on
-	technique
-	{
-		pass
-		{
-			ambient 0.500000 0.500000 0.500000 1.000000
-			diffuse 0.658880 0.658880 0.658880 1.000000
-			emissive 0.000000 0.000000 0.000000 1.000000
-			texture_unit
-			{
-				texture planet_Muunilinst.png
-				colour_op modulate
-			}
-		}
-		pass
-		{
-			ambient 0.0 0.0 0.0
-			diffuse 0.0 0.0 0.0
-			specular 0.000000 0.000000 0.000000 1.000000 127.750000
-			scene_blend add
-		}
-	}
-}
Index: /data/trunk/materials/OrxonoxSky.material
===================================================================
--- /data/trunk/materials/OrxonoxSky.material	(revision 8424)
+++ /data/trunk/materials/OrxonoxSky.material	(revision 8425)
@@ -170,4 +170,21 @@
 			{
 				cubic_texture skybox2.png separateUV
+				tex_address_mode clamp
+			}
+		}
+	}
+}
+material Orxonox/skyboxempty
+{
+	technique
+	{
+		pass
+		{
+			lighting off
+			depth_write off
+
+			texture_unit
+			{
+				cubic_texture SkyboxEmpty.png separateUV
 				tex_address_mode clamp
 			}
Index: ta/trunk/materials/Planet3.material
===================================================================
--- /data/trunk/materials/Planet3.material	(revision 8424)
+++ 	(revision )
@@ -1,25 +1,0 @@
-material Planet3Tex/TEXFACE/planet_3.png
-{
-	receive_shadows on
-	technique
-	{
-		pass
-		{
-			ambient 0.500000 0.500000 0.500000 1.000000
-			diffuse 1.000000 1.000000 1.000000 1.000000
-			emissive 0.000000 0.000000 0.000000 1.000000
-			texture_unit
-			{
-				texture planet_3.png
-				colour_op modulate
-			}
-		}
-		pass
-		{
-			ambient 0.0 0.0 0.0
-			diffuse 0.0 0.0 0.0
-			specular 0.000000 0.000000 0.000000 1.000000 12.500000
-			scene_blend add
-		}
-	}
-}
Index: ta/trunk/materials/earth.material
===================================================================
--- /data/trunk/materials/earth.material	(revision 8424)
+++ 	(revision )
@@ -1,25 +1,0 @@
-material EarthTex/TEXFACE/earth.png
-{
-	receive_shadows on
-	technique
-	{
-		pass
-		{
-			ambient 0.500000 0.500000 0.500000 1.000000
-			diffuse 1.000000 1.000000 1.000000 1.000000
-			emissive 0.000000 0.000000 0.000000 1.000000
-			texture_unit
-			{
-				texture earth.png
-				colour_op modulate
-			}
-		}
-		pass
-		{
-			ambient 0.0 0.0 0.0
-			diffuse 0.0 0.0 0.0
-			specular 0.000000 0.000000 0.000000 1.000000 12.500000
-			scene_blend add
-		}
-	}
-}
Index: ta/trunk/materials/ganymede.material
===================================================================
--- /data/trunk/materials/ganymede.material	(revision 8424)
+++ 	(revision )
@@ -1,25 +1,0 @@
-material ganymede/TEXFACE/ganymede.png
-{
-	receive_shadows on
-	technique
-	{
-		pass
-		{
-			ambient 0.500000 0.500000 0.500000 1.000000
-			diffuse 1.000000 1.000000 1.000000 1.000000
-			emissive 0.000000 0.000000 0.000000 1.000000
-			texture_unit
-			{
-				texture ganymede.png
-				colour_op modulate
-			}
-		}
-		pass
-		{
-			ambient 0.0 0.0 0.0
-			diffuse 0.0 0.0 0.0
-			specular 0.000000 0.000000 0.000000 1.000000 12.500000
-			scene_blend add
-		}
-	}
-}
Index: ta/trunk/materials/jupiter.material
===================================================================
--- /data/trunk/materials/jupiter.material	(revision 8424)
+++ 	(revision )
@@ -1,25 +1,0 @@
-material jupiter/TEXFACE/jupiter.png
-{
-	receive_shadows on
-	technique
-	{
-		pass
-		{
-			ambient 0.500000 0.500000 0.500000 1.000000
-			diffuse 1.000000 1.000000 1.000000 1.000000
-			emissive 0.000000 0.000000 0.000000 1.000000
-			texture_unit
-			{
-				texture jupiter.png
-				colour_op modulate
-			}
-		}
-		pass
-		{
-			ambient 0.0 0.0 0.0
-			diffuse 0.0 0.0 0.0
-			specular 0.000000 0.000000 0.000000 1.000000 12.500000
-			scene_blend add
-		}
-	}
-}