Index: code/branches/steering/data/levels/templates/spaceshipAssff.oxt
===================================================================
--- code/branches/steering/data/levels/templates/spaceshipAssff.oxt	(revision 8429)
+++ code/branches/steering/data/levels/templates/spaceshipAssff.oxt	(revision 8430)
@@ -14,5 +14,8 @@
    primaryThrust     = 100;
    auxilaryThrust    = 30;
-   rotationThrust    = 25;
+   rotationThrust    = 60;
+
+   lift = 0.2;
+   stallSpeed = 220;
 
    collisionType     = "dynamic"
Index: code/branches/steering/src/orxonox/worldentities/MobileEntity.cc
===================================================================
--- code/branches/steering/src/orxonox/worldentities/MobileEntity.cc	(revision 8429)
+++ code/branches/steering/src/orxonox/worldentities/MobileEntity.cc	(revision 8430)
@@ -83,4 +83,6 @@
                 this->linearVelocity_.z += this->linearAcceleration_.z * dt;
                 this->node_->translate(this->linearVelocity_ * dt);
+
+    
 
                 // Angular part
Index: code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.cc
===================================================================
--- code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8429)
+++ code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8430)
@@ -36,4 +36,6 @@
 #include "core/XMLPort.h"
 #include "items/Engine.h"
+#include "util/Debug.h"
+
 
 namespace orxonox
@@ -52,5 +54,5 @@
         this->localLinearAcceleration_.setValue(0, 0, 0);
         this->localAngularAcceleration_.setValue(0, 0, 0);
-        this->bBoost_ = false;
+	this->bBoost_ = false;
         this->steering_ = Vector3::ZERO;
         this->engine_ = 0;
@@ -63,4 +65,7 @@
         this->bBoostCooldown_ = false;
 
+	this->lift_ = 0.2f;
+	this->stallSpeed = 220.0f;
+
         this->bInvertYAxis_ = false;
 
@@ -75,5 +80,9 @@
         this->setConfigValues();
         this->registerVariables();
-    }
+
+
+
+	
+}
 
     SpaceShip::~SpaceShip()
@@ -95,4 +104,6 @@
         XMLPortParamVariable(SpaceShip, "boostRate", boostRate_, xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "boostCooldownDuration", boostCooldownDuration_, xmlelement, mode);
+	XMLPortParamVariable(SpaceShip, "float", float_, xmlelement, mode);
+	XMLPortParamVariable(SpaceShip, "stallSpeed", stallSpeed_, xmlelement, mode);
     }
 
@@ -163,4 +174,7 @@
                 }
             }
+	
+COUT(1) << "Vel:" << this-> getLocalVelocity().z * -1 << endl;
+		
         }
     }
@@ -175,4 +189,5 @@
         this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() - value.x);
         this->steering_.z = -value.x;
+
     }
 
@@ -181,4 +196,5 @@
         this->localLinearAcceleration_.setX(this->localLinearAcceleration_.x() + value.x);
         this->steering_.x = value.x;
+ 
     }
 
@@ -187,4 +203,9 @@
         this->localLinearAcceleration_.setY(this->localLinearAcceleration_.y() + value.x);
         this->steering_.y = value.x;
+
+
+
+
+
     }
 
@@ -194,11 +215,20 @@
 
         Pawn::rotateYaw(value);
+
     }
 
     void SpaceShip::rotatePitch(const Vector2& value)
     {
-        this->localAngularAcceleration_.setX(this->localAngularAcceleration_.x() + value.x);
+        this->localAngularAcceleration_.setX(this->localAngularAcceleration_.x() + value.x * 0.8);
 
         Pawn::rotatePitch(value);
+
+	
+	
+	if (abs(this-> getLocalVelocity().z) < stallSpeed)  {this->moveUpDown(float_*value*sqrt(abs(this-> getLocalVelocity().z)));}
+
+	
+
+
     }
 
@@ -208,4 +238,5 @@
 
         Pawn::rotateRoll(value);
+ 
     }
 
Index: code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.h
===================================================================
--- code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8429)
+++ code/branches/steering/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8430)
@@ -89,4 +89,6 @@
             float boostPowerRate_;
             float boostCooldownDuration_;
+	    float lift_;
+	    float stallSpeed_;
             Vector3 steering_;
             float primaryThrust_;
@@ -96,4 +98,6 @@
             btVector3 localAngularAcceleration_;
 
+	  
+
         private:
             void registerVariables();
@@ -101,5 +105,5 @@
 
             void loadEngineTemplate();
-            
+
             void boostCooledDown(void);
 